using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinEditors;

namespace WinGrid___Different_Formats_in_the_Same_Column_CS
{
    public partial class Form1 : Form
    {
        #region Private Members
        EditorCache editorCache;
        #endregion //Private Members

        #region Constructor
        public Form1()
        {
            InitializeComponent();
        }
        #endregion //Constructor

        #region ultraGrid1_InitializeRow
        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            // In this example, the "Format" column will determine the format for the 
            // "Value" column. 
            string format = e.Row.GetCellText(e.Row.Band.Columns["Format"]);

            // Get an EmbeddableEditorBase that has a default owner with the specified
            // format. 
            EmbeddableEditorBase editor = this.EditorCache.GetEditor(format);

            // Assign the editor to the column. 
            e.Row.Cells["Value"].Editor = editor;
        }
        #endregion //ultraGrid1_InitializeRow

        #region ultraGrid1_InitializeLayout
        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // AutoSize the columns just so they look nicer. 
            foreach (UltraGridColumn column in e.Layout.Bands[0].Columns)
                column.PerformAutoResize(PerformAutoSizeType.AllRowsInBand);
        }
        #endregion //ultraGrid1_InitializeLayout

        #region EditorCache
        private EditorCache EditorCache
        {
            get
            {
                if (this.editorCache == null)
                    this.editorCache = new EditorCache();

                return this.editorCache;
            }
        }
        #endregion //EditorCache       
    }
}